module A4Tools
  class KaiConfigClient < CachingClient
    attr_accessor :cache_timeout

    #cache :getConfigWebVersion, :authenticate => true

    query :configValueRequest, :authenticate => true do |id_config|
      {
        idConfig:id_config
      }
    end

    def strip_wrapper(result)
      body = result[:configValueWrappers][0][:wrappedConfigValues][0][:body]
      body[:__class] = result[:configValueWrappers][0][:wrappedConfigValues][0][:className]
      body
    end

    def site_version
      response_body(send_message(empty_query(:getConfigWebVersion)))[:stringValue] rescue nil
    end

    def section_bank_info
      strip_wrapper(query(:configValueRequest, talk["SECTION_BANK_LOCATION_VALUES"]))
    end

    def machines
      (section_bank_info[:locations].map { |loc| loc[:location] })
    end

    def sections
      (section_bank_info[:sections].map { |sect| sect[:sectionName] })
    end

    def banks
      (section_bank_info[:banks].map { |bank| bank[:bankName] })
    end
  end
end
