module A4Tools
  class EventManager
    attr_accessor :events

    def initialize(events=nil)
      events = File.read(File.join(File.dirname(__FILE__), "events.json")) if events.nil?
      events = File.read(events) if events.is_a? String and File.exists? events
      events = JSON.parse(events) if events.is_a? String

      @events = transform_events(events)
    end

    def transform_events(events)
      events.map do |event|
        { code:event["code"].to_i, key:event["key"].to_sym, description:event["description"] }
      end
    end

    def event(id)
      @events.each { |event| return event if event[:code] == id.to_i or event[:key] == id.to_sym }
      nil
    end
  end
end
