category "Shell management"
description "Get contents of environment variables"
usage "[variable_name]"
help <<-EOS
List the value of environment variable ENV, or all environment variables if not specified.

Environment variables are NOT imported from your system's native shell.
EOS

validate do
  case args.length
  when 1
    true
  when 2
    if @shell.get_env(args[1]).nil?
      "#{args[1]}: key not set"
    else
      true
    end
  else
    false
  end
  true
end

tab 0 do
  @shell.env.keys
end

run do
  if args.length == 2 then
    @shell.get_env(args[1])
  else
    list = []
    @shell.env.each { |key, value| list.push "#{key.to_s.style(:environment)}: \"#{value.to_s.bold}\"" }
    list.join("\n")
  end
end
