category "Shell management"
description "Persist an environment variable"
usage "variable1 variable2 ..."

help "Causes an evironment variable to persist between netshell sessions."

tab do
  @shell.env.keys.reject { |key| args.include? key.to_s }
end

validate { (args.length >= 2 and not params[:all]) or (args.length == 1 and params[:all]) }

opt :all, "Persist all variables"

run do
  variables = if params[:all]
    [] # causes persist to save everything
  else
    args[1..-1]
  end

  @shell.persist_env(variables)
  ""
end
