category "Protocol manipulation"
description "Select a connection for console"
usage "select [conenction]"


tab(0) { @shell.clients }

run do
  if args.length == 1 then
    (@shell.clients.sort.map { |key| render_client(key) }).join("\n")
  else
    return show_error("#{args[1]}: no such client") unless @shell.clients.include?(args[1].to_sym)
    @shell.set_active_client(args[1])
    ""
  end
end

def render_client(key)
  target = @shell.client(key)
  fmt_key = sprintf("%20s", key.to_s)
  host = usherm.host_for_url(target.uri) || "unknown host"
  info = source_id(target)

  "#{fmt_key.style(:target)}: #{info} #{target.uri.to_s.style(:url)} (#{host.style(:host)})"
end

def source_id(target)
  app_info = target.server_info || {}
  version = target.version || app_info[:currentTalkVersion]
  protocol = sprintf("%-6s", (version || "")).style(:protocol_name)
  name = sprintf("%20s", ((app_info[:appName] rescue nil) || "")).style(:name)
  commit = sprintf("%7s", ((app_info[:sourceRevision][0..6] rescue nil) || "")).style(:commit)
  branch = sprintf("%-30s", ((app_info[:supportingRevisions].first[:branches].first rescue nil) || "")).style(:branch)

  "#{protocol} #{commit} #{branch}"
end
