category "Shell management"
description "Set environment variables"
usage "variable value"

help <<-EOS
Sets an environment variable to a specified value. Environment variables may also be set by creating
  ~/.netshell/env

At shell initialization, this directory (if it exists) will be scanned. For each filename in the directory, an environment variable with that name will be created, and populated with the contents of that file.

Environment variables are NOT imported from your system's native shell.
EOS

validate { args.length == 2 or args.length == 3 }

tab(0) do
  @shell.env.keys
end

run do
  value = if args.length == 3 then
    args[2 .. -1].join(" ")
  else
    @input.read_all.chomp
  end
  @shell.set_env(args[1].to_sym, value)
  ""
end

