category "Usher"
description "Connect to UsherM"
usage "[username] [password]"

help <<-EOS
Connects to UsherM server. This connection is not related to the connection opened in #{"connect".style(:command)}; only the #{"usherm".style(:command)} family of commands make use of this connection.

If username and password are omitted, they are defaulted from the #{"usherm_user".style(:environment)} and #{"usherm_pass".style(:environment)} environment variables, if set.

If the #{"usherm_user".style(:environment)} and #{"usherm_pass".style(:environment)} environment variables are set when the shell starts, this connection is created automatically.
EOS

run do
  cmd_user = args[1] rescue nil
  cmd_pass = args[2] rescue nil
  username = cmd_user || @shell.get_env(:usherm_user)
  password = cmd_pass || @shell.get_env(:usherm_pass)
  return show_error(usage_msg) unless password
  @shell.set_client(:usherm, UsherMgmtClient.new(nil, username, password))
  ""
end
