require 'colorize'

class String
  def style_category
    return self.colorize(:blue).bold
  end

  def style_class
    return self.colorize(:light_black) if self == "none"

    comps = split(".")
    (comps.map do |comp|
      if comp == comps.last then
        comp.colorize(:red).bold
      else
        comp.colorize(:light_black)
      end
      
    end).join(".")
  end

  def style_constant_name
    self.colorize(:red)
  end

  def style_constant_value
    self.colorize(:green).bold
  end

  def style_collection_name
    comps = split(".")
    (comps.map do |comp|
      if comp == comps.last then
        comp.colorize(:green).bold
      else
        comp.colorize(:light_black)
      end
      
    end).join(".")
  end

  def style_protocol_name
    self.colorize(:light_blue).bold
  end

  def style_method_name
    self.colorize(:blue)
  end

  def style_field_name
    self.colorize(:red)
  end

  def style_field_datatype
    self.colorize(:magenta)
  end

  def style_origin
    self.colorize(:magenta)
  end

  def style_command
    self.colorize(:magenta).bold
  end

  def style_environment
    self.colorize(:red)
  end

  def style_datacenter
    self.colorize(:green)
  end

  def style_host
    self.colorize(:red)
  end

  def style_ip
    self.colorize(:blue)
  end

  def style_service
    self.colorize(:magenta)
  end

  def style_product
    self.colorize(:red).bold
  end

  def style_event_code
    self.colorize(:blue).bold
  end

  def style_event_key
    self.colorize(:red)
  end

  def style_error
    self.colorize(:red).bold
  end

  def style_userdefined
    self.colorize(:light_black).bold
  end

  def style_id
    self.colorize(:green)
  end

  def style_build_name
    self.bold
  end

  def style_branch
    self.colorize(:red)
  end

  def style_timestamp
    self.colorize(:blue)
  end

  def style_author
    self.colorize(:light_black)
  end

  def style_cidr
    ip, whack = self.split("/")
    return self.colorize(:red) if ip.nil? or whack.nil?
    ip.colorize(:red) + "/" + whack.colorize(:magenta)
  end

  def style_heading
    self.bold
  end

  def style_client
    self.bold
  end

  def style(type)
    method = ("style_" + type.to_s).to_sym
    return send(method) if self.methods.include?(method)
    self
  end

  def unstyle
    self.uncolorize
  end
end
